Subject: bug#73204: Tree-sitter in clojure-ts-mode causes memory leak during parsing

From: Yuan Fu <[email-masked]>
Date: Sat, 14 Sep 2024 00:58:50 -0700

> On Sep 12, 2024, at 9:24 PM, Yuan Fu <[email-masked]> wrote:
> 
> 
> 
>> On Sep 12, 2024, at 9:21 AM, vinurs <[email-masked]> wrote:
>> 
>> Hi,
>> 
>> I am using the precompiled version from https://emacsformacosx.com/builds 
>> https://emacsformacosx.com/emacs-builds/Emacs-2024-09-11_00-09-10-69e1aca041c57ba425425d31471e1c8f86d3bf04-universal.dmg
>> 
>> I have chosen the latest Emacs 30 version. The min configuration is as follows:
>> 
>> (add-to-list 'treesit-extra-load-path (expand-file-name "tree-sitter/" user-emacs-directory))
>> (add-to-list 'load-path "~/.emacs.d/site-lisp/clojure-ts-mode”) 
>> (require 'clojure-ts-mode) 
>> ;; debug 
>> (setq debug-on-quit t)
>> 
>> and I only use clojure-ts-mode package
>> 
>> cd ~/.emacs.d/site-lisp
>> git clone https://github.com/clojure-emacs/clojure-ts-mode.git
>> 
>> Then, after opening Emacs, 
>> I opened the attached file b.clj, moved to line 57, 
>> and entered the following characters: 
>> (comment
>> 
>> At this point, Emacs freezes and becomes unresponsive. I noticed that Emacs' memory usage keeps increasing:
>> 2024-09-12 21:12:23: 806624 KB
>> 2024-09-12 21:12:28: 810720 KB
>> 2024-09-12 21:12:33: 829840 KB
>> 2024-09-12 21:12:38: 1582256 KB
>> 2024-09-12 21:12:43: 4678816 KB
>> 2024-09-12 21:12:48: 7831776 KB
>> 2024-09-12 21:12:53: 10982384 KB
>> 2024-09-12 21:12:58: 14140048 KB
>> 2024-09-12 21:13:03: 17296176 KB
>> 2024-09-12 21:13:08: 20440960 KB
>> 2024-09-12 21:13:13: 23583008 KB
>> 2024-09-12 21:13:18: 26726272 KB
>> 2024-09-12 21:13:24: 29857312 KB
>> 2024-09-12 21:13:29: 33011456 KB
>> 2024-09-12 21:13:34: 36156624 KB
>> 2024-09-12 21:13:39: 38685440 KB
>> 2024-09-12 21:13:44: 34858560 KB
>> 2024-09-12 21:13:49: 30892768 KB
>> 
>> Then, Emacs eventually gets killed by the system.
>> The bt.log is the information I was able to retrieve
>> ------------
>> Sincerely,<b.clj><bt.log>
> 
> Hi vinurs, 
> 
> Thank you for your detailed report! This looks very similar to bug#72863, which we determined to be a tree-sitter bug. In both that bug and this, ts_parser_parse falls into an inf loop.
> 
> Your test file also uncovered another Emacs bug. I need fix this ASAP (emacs 30 pre-release is already out 😬). Once that’s fixed I’ll check if the hang is due to the same tree-sitter bug.
> 
> Yuan

I fixed the bug I discovered; and guess what, that totally fixed this bug! So this bug isn’t caused by the tree-sitter bug, despite having similar symptoms.

When the next pretest comes out, please give it a try and see if you can still see the bug. Or you can clone the emacs-30 branch and check it out now.

Thanks again for the report! Would’ve been really bad if we didn’t discover this bug before releasing Emacs 30.

Yuan